CON

  _clkmode = xtal1 + pll16x                                                     ' use crystal x 16
  _xinfreq = 5_000_000                                                          ' 5 MHz cyrstal (sys clock = 80 MHz)

  adcCS_Pin = 13                                                                'pins used for ADC chip
  adcCLK_Pin = 15
  adcDO_Pin = 14
  INIT_OK = 0   

OBJ

  lcd     : "LCD_16X2_8BIT" 
  ADC     : "ADC_Driver"
  
VAR

  long volts_Bin                                                                'adc value in binary (I think thats what this is)              
  byte ADC_value                                                                'adc value can range from 0 to 255
  long volt_calc                                                                'adc value multiplied by volt_step (volt step should = 5/255)
  long volt_step                                                                'should be equal to 5/255  this number repersents the voltage per 1 step of adc 
       
PUB ini
  
  lcd.start                                                                    
  lcd.move(1,1)                                     
  lcd.str(string("kWH PROJECT"))
  lcd.move(1,2)
  lcd.str(string("WKU"))
  waitcnt(clkfreq*2 + cnt)
    
  main  

pub main | rcLCD, rcADC

 
  lcd.clear                                                                     
  lcd.move(1,1)              
  lcd.str(string("volts"))
  rcADC := ADC.Init(adcCS_Pin, adcCLK_Pin, adcDO_Pin)
      
  if rcADC <> INIT_OK
    LCD.Str(string("ADC chip init err"))
    return

  volt_step :=(50000/255)
  
  repeat                               
    LCD.move(10, 1)                                            
    volts_bin := ADC.GetConvertedVal                                           
    ADC_value := volts_bin &= 255                                              
    volt_Calc := ADC_value*volt_step    
   DecPoint(volt_calc, 10000)
    waitcnt(clkfreq/2 + cnt)                                                    

PUB DecPoint(value, denominator) 
  if value < 0
    LCD.Str(string("-"))
    -value
      
  if value > denominator
    result := value / denominator
    lcd.dec(result)
    value //= denominator     
  else    
    LCD.Str(string("0"))
  LCD.Str(string("."))  
  repeat while denominator > 1
    denominator /= 10
    if value > denominator
      result := value / denominator
      lcd.dec(result)
      value //= denominator
    else
      LCD.Str(string("0")) 